/**
 * Create a new `EConstructor`, with the formatted `format` as a first argument.
 *
 * @template {Error} Fault
 * @template {new (reason: string) => Fault} Class
 * @param {Class} Constructor
 */
export function create<
  Fault extends Error,
  Class extends new (reason: string) => Fault
>(
  Constructor: Class
): {
  (format?: string, ...values: unknown[]): Fault
  /** @type {string} */
  displayName: string
}
export var fault: {
  (format?: string, ...values: unknown[]): Error
  /** @type {string} */
  displayName: string
} & {
  eval: {
    (format?: string, ...values: unknown[]): Error
    /** @type {string} */
    displayName: string
  }
  range: {
    (format?: string, ...values: unknown[]): Error
    /** @type {string} */
    displayName: string
  }
  reference: {
    (format?: string, ...values: unknown[]): Error
    /** @type {string} */
    displayName: string
  }
  syntax: {
    (format?: string, ...values: unknown[]): Error
    /** @type {string} */
    displayName: string
  }
  type: {
    (format?: string, ...values: unknown[]): Error
    /** @type {string} */
    displayName: string
  }
  uri: {
    (format?: string, ...values: unknown[]): Error
    /** @type {string} */
    displayName: string
  }
}
